#!/system/bin/sh
set_sys_def_scaling_governor()
{
	local i=60
	while [ $i -gt 0 ]; do
		if [ "$(cat /sys/devices/system/cpu/cpufreq/policy0/scaling_governor)" ==  "performance" ]; then
			sleep 1
			i=$(($i-1))
		else
			SYS_DEF_SCALING_GOVERNOR=`cat /sys/devices/system/cpu/cpufreq/policy0/scaling_governor`
			i=0
		fi
	done
	if [ -z "$SYS_DEF_SCALING_GOVERNOR" ]; then
		if cat /sys/devices/system/cpu/cpufreq/policy0/scaling_available_governors | grep "walt" >/dev/null; then
			SYS_DEF_SCALING_GOVERNOR=walt
		elif cat /sys/devices/system/cpu/cpufreq/policy0/scaling_available_governors | grep "schedutil" >/dev/null; then
			SYS_DEF_SCALING_GOVERNOR=schedutil
		elif cat /sys/devices/system/cpu/cpufreq/policy0/scaling_available_governors | grep "ondemand" >/dev/null; then
			SYS_DEF_SCALING_GOVERNOR=ondemand
		else
			exit 0
		fi
	fi
}
performance_mode()
{
	if [ "$(getprop sutoliu.powered_on_performance_enhancements)" ==  "Y" ]; then
		if cat /sys/devices/system/cpu/cpufreq/policy0/scaling_available_governors | grep "performance" >/dev/null; then
			for SCALING_GOVERNOR_PATH in `ls /sys/devices/system/cpu/cpufreq/policy*/scaling_governor`; do
				echo "performance" > $SCALING_GOVERNOR_PATH
			done
		fi
		if [ -f /sys/devices/system/cpu/qcom_lpm/parameters/sleep_disabled ]; then
			echo "1" > /sys/devices/system/cpu/qcom_lpm/parameters/sleep_disabled
		elif [ -f /sys/module/lpm_levels/parameters/sleep_disabled ]; then
			echo "Y" > /sys/module/lpm_levels/parameters/sleep_disabled
		fi
		for POLICY_PATH in `ls -d /sys/devices/system/cpu/cpufreq/policy*`; do
			if [ -f $POLICY_PATH/cpuinfo_max_freq ] && [ -f $POLICY_PATH/scaling_min_freq ]; then
				echo "$(cat $POLICY_PATH/cpuinfo_max_freq)" > $POLICY_PATH/scaling_min_freq
			fi
		done
	fi
}
balanced_mode()
{
	if [ "$(getprop sutoliu.powered_on_performance_enhancements)" ==  "Y" ]; then
		if cat /sys/devices/system/cpu/cpufreq/policy0/scaling_available_governors | grep "$SYS_DEF_SCALING_GOVERNOR" >/dev/null; then
			for SCALING_GOVERNOR_PATH in `ls /sys/devices/system/cpu/cpufreq/policy*/scaling_governor`; do
				echo "$SYS_DEF_SCALING_GOVERNOR" > $SCALING_GOVERNOR_PATH
			done
		fi
		if [ -f /sys/devices/system/cpu/qcom_lpm/parameters/sleep_disabled ]; then
			echo "0" > /sys/devices/system/cpu/qcom_lpm/parameters/sleep_disabled
		elif [ -f /sys/module/lpm_levels/parameters/sleep_disabled ]; then
			echo "N" > /sys/module/lpm_levels/parameters/sleep_disabled
		fi
		for POLICY_PATH in `ls -d /sys/devices/system/cpu/cpufreq/policy*`; do
			if [ -f $POLICY_PATH/cpuinfo_min_freq ] && [ -f $POLICY_PATH/scaling_min_freq ]; then
				echo "$(cat $POLICY_PATH/cpuinfo_min_freq)" > $POLICY_PATH/scaling_min_freq
			fi
		done
	fi
}
set_sys_def_scaling_governor
while true; do
	sleep 1
	dumpsys battery reset
	local BATTERY_STATUS="$(echo "$(dumpsys battery)" | egrep 'status: ' | sed -n 's/.*status: //g;$p')"
	if [ $BATTERY_STATUS == "2" ] || [ $BATTERY_STATUS == "5" ]; then
		performance_mode
		local i=1
		while [ "$i" -gt "0" ]; do
			sleep 1
			local BATTERY_STATUS="$(echo "$(dumpsys battery)" | egrep 'status: ' | sed -n 's/.*status: //g;$p')"
			if [ $BATTERY_STATUS == "2" ] || [ $BATTERY_STATUS == "5" ]; then
				i=1
			else
				i=0
			fi
		done
	else
		balanced_mode
		local i=1
		while [ "$i" -gt "0" ]; do
			sleep 6
			local BATTERY_STATUS="$(echo "$(dumpsys battery)" | egrep 'status: ' | sed -n 's/.*status: //g;$p')"
			if [ $BATTERY_STATUS == "2" ] || [ $BATTERY_STATUS == "5" ]; then
				i=0
			else
				i=1
			fi
		done
	fi
done
